<!doctype html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <title>Verso-DemoKit documentation</title>
  <meta name="description" content="Verso-DemoKit documentation">
  <meta name="author" content="Dahlia">
  <link rel="stylesheet" type="text/css" href="style.css">
  <link rel="stylesheet" href="highlightjs/styles/darkula.css">
  <script src="highlightjs/highlight.pack.js"></script>
  <script>hljs.initHighlightingOnLoad();</script>
</head>
<body>

<h1>Verso-DemoKit documentation</h1>

<h2>Table of Contents</h2>

<div><a href="#general-info">1. General info</a></div>
<div><a href="#demokit-json">2. DemoKit JSON format</a></div>
<div><a href="#demokit-demopart">2. Demopart format</a></div>
<div><a href="#verso.clearscreen">2.1. verso.clearscreen params</a></div>
<div class="line-through"><a href="#verso.heightmap">2.2. verso.heightmap</a></div>
<div><a href="#verso.imageviewer">2.3. verso.imageviewer params</a></div>
<div class="line-through"><a href="#verso.imguitest">2.4. verso.imguitest params</a></div>
<div><a href="#verso.particles">2.5. verso.particles params</a></div>
<div><a href="#verso.randombackground">2.6. verso.randombackground params</a></div>
<div class="line-through"><a href="#verso.scenegraph">2.7. verso.scenegraph params format</a></div>
<div><a href="#verso.shadertoy">2.8. verso.shadertoy params</a></div>
<div class="line-through"><a href="#verso.verso-3dtest">2.9. verso.verso-3dtest params</a></div>
<div><a href="#types">3. Types</a></div>
<div><a href="#types.null">3.1. null type</a></div>
<div><a href="#types.object">3.2. object type</a></div>
<div><a href="#types.array">3.3. array type</a></div>
<div><a href="#types.boolean">3.4. boolean type</a></div>
<div><a href="#types.number">3.5. number type</a></div>
<div><a href="#types.integer">3.6. integer number type</a></div>
<div><a href="#types.string">3.7. string type</a></div>
<div><a href="#types.Align">3.8. Align type</a></div>
<div><a href="#types.Color">3.9. Color type</a></div>
<div><a href="#types.Rangef">3.10. Rangef type</a></div>
<div><a href="#types.Rectf">3.11. Rectf type</a></div>
<div><a href="#types.Vector2f">3.12. Vector2f type</a></div>
<div><a href="#types.Vector2i">3.13. Vector2i type</a></div>
<div><a href="#types.Vector3f">3.14. Vector3f type</a></div>
<div><a href="#types.BlendMode">3.15. BlendMode type</a></div>
<div><a href="#types.ClearFlag">3.16. ClearFlag type</a></div>
<div><a href="#types.MinFilter">3.17. MinFilter type</a></div>
<div><a href="#types.MagFilter">3.18. MagFilter type</a></div>
<div><a href="#types.PlayMode">3.19. PlayMode type</a></div>
<div><a href="#types.CameraTimeline">3.20. CameraTimeline type</a></div>
<div><a href="#types.BehaviourParam">3.21. BehaviourParam type</a></div>
<div><a href="#types.BehaviourParam.type=SimpleGravity">3.21.1. BehaviourParam.type="SimpleGravity"</a></div>
<div><a href="#types.ChannelParam">3.22. ChannelParam type</a></div>
<div><a href="#types.ClearParam">3.23. ClearParam type</a></div>
<div><a href="#types.EmitterParam">3.24. EmitterParam type</a></div>
<div><a href="#types.EmitterParam.type=SimpleRandom">3.24.1. EmitterParam.type="SimpleRandom"</a></div>
<div><a href="#types.EmitterParam.type=SphericalRandom">3.24.2. EmitterParam.type="SphericalRandom"</a></div>
<div><a href="#types.Material3dParam">3.25. Material3dParam type</a></div>
<div><a href="#types.ParticlesParam">3.26. ParticlesParam type</a></div>
<div><a href="#types.PhongMaterialParam">3.27. PhongMaterialParam type</a></div>
<div><a href="#types.SequencerParam">3.28. SequencerParam type</a></div>
<div><a href="#types.SequencerParam.type=BurstInterval">3.28.1. SequencerParam.type="BurstInterval"</a></div>
<div><a href="#types.ShaderParam">3.29. ShaderParam type</a></div>



<div><a href="#full-examples">4. Full examples</a></div>
<div><a href="#full-examples-particles">4.1. particles.json</a></div>


<h2 id="general-info">1. General info</h2>

<p>DemoKit is a demo engine over the <a href="https://gitlab.com/dahliazone/pc/lib/verso-3d">verso-3d</a> library that provides you ways to compose, parametrisize, time and run several effects in a timeline. Concept is quite similar to how video editing software work, except that each block in the timeline is chosen to be certain effect which in turn then defined what will be rendered. In DemoKit these block are called DemoParts.</p>

<p>A demo can be defined in a <a href="https://en.wikipedia.org/wiki/JSON">JSON</a> based custom format which is be presented in this document. You can use built-in DemoParts or use C++ code to create your own custom effects.</p>

<h2 id="demokit-json">2. DemoKit JSON format</h2>

<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr id="demokit.format" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"format":</th>
    <td colspan="4">
Format version number to future proofing.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="required">required</span><br />
<span class="bold">Supported values:</span> <span class="string">"DemoKit01"</span>
    </td>
  </tr>

  <tr id="demokit.name">
    <th>&nbsp;</th>
    <th colspan="3">"name":</th>
    <td colspan="4">
Name of the demo.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="required">required</span><br />
<span class="bold">Example:</span> <span class="string">"Enlil, king of all the lands, father of all the gods"</span>
    </td>
  </tr>

  <tr id="demokit.version" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"version":</th>
    <td colspan="4">
Free-form text version name for the demo.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="required">required</span><br />
<span class="bold">Example:</span> <span class="string">"2018/05/02 some identification"</span>
    </td>
  </tr>

  <tr id="demokit.authors">
    <th>&nbsp;</th>
    <th colspan="3">"authors":</th>
    <td colspan="4">
Free-form list of authors.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="required">required</span><br />
<span class="bold">Example:</span> <span class="string">"codise / dahlia"</span>
    </td>
  </tr>

  <tr id="demokit.paths" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"paths": {</th>
    <td colspan="4">
<span class="object">Object</span> containing the paths to data files.<br />
<span class="bold">Type:</span> <span class="object">object</span> <span class="optional">optional</span>
    </td>
  </tr>

	  <tr id="demokit.paths.models">
	    <th>&nbsp;</th>
	    <th>&nbsp;</th>
	    <th colspan="2">"models":</th>
	    <td colspan="4">
	Directory path to where the 3D objects will be loaded relative to DemoKit JSON file path.<br />
	<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="optional">optional</span><br />
	<span class="bold">Default:</span> <span class="string">"models"</span>
	    </td>
	  </tr>

	  <tr id="demokit.paths.shaders" class="odd">
	    <th>&nbsp;</th>
	    <th>&nbsp;</th>
	    <th colspan="2">"shaders":</th>
	    <td colspan="4">
	Directory path to where the shader sources will be loaded relative to DemoKit JSON file path.<br />
	<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="optional">optional</span><br />
	<span class="bold">Default:</span> <span class="string">"shaders"</span>
	    </td>
	  </tr>

	  <tr id="demokit.paths.material">
	    <th>&nbsp;</th>
	    <th>&nbsp;</th>
	    <th colspan="2">"material":</th>
	    <td colspan="4">
	Directory path to where the material shader sources will be loaded relative to DemoKit JSON file path.<br />
	<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="optional">optional</span><br />
	<span class="bold">Default:</span> <span class="string">"shaders/material"</span>
	    </td>
	  </tr>

	  <tr id="demokit.paths.music" class="odd">
	    <th>&nbsp;</th>
	    <th>&nbsp;</th>
	    <th colspan="2">"music":</th>
	    <td colspan="4">
	Directory path to where the music will be loaded relative to DemoKit JSON file path.<br />
	<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="optional">optional</span><br />
	<span class="bold">Default:</span> <span class="string">"music"</span>
	    </td>
	  </tr>

	  <tr id="demokit.paths.textures">
	    <th>&nbsp;</th>
	    <th>&nbsp;</th>
	    <th colspan="2">"textures":</th>
	    <td colspan="4">
	Directory path to where the textures will be loaded relative to DemoKit JSON file path.<br />
	<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="optional">optional</span><br />
	<span class="bold">Default:</span> <span class="string">"textures"</span>
	    </td>
	  </tr>

	  <tr id="demokit.paths.fonts" class="odd">
	    <th>&nbsp;</th>
	    <th>&nbsp;</th>
	    <th colspan="2">"fonts":</th>
	    <td colspan="4">
	Directory path to where the fonts will be loaded relative to DemoKit JSON file path.<br />
	<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="optional">optional</span><br />
	<span class="bold">Default:</span> <span class="string">"fonts"</span>
	    </td>
	  </tr>

	  <tr id="demokit.paths.particles">
	    <th>&nbsp;</th>
	    <th>&nbsp;</th>
	    <th colspan="2">"particles":</th>
	    <td colspan="4">
	Directory path to where the particle textures will be loaded relative to DemoKit JSON file path.<br />
	<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="optional">optional</span><br />
	<span class="bold">Default:</span> <span class="string">"particles"</span>
	    </td>
	  </tr>

	  <tr id="demokit.paths.gui" class="odd">
	    <th>&nbsp;</th>
	    <th>&nbsp;</th>
	    <th colspan="2">"gui":</th>
	    <td colspan="4">
	Directory path to where the gui textures will be loaded relative to DemoKit JSON file path.<br />
	<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="optional">optional</span><br />
	<span class="bold">Default:</span> <span class="string">"gui"</span>
	    </td>
	  </tr>

	  <tr id="demokit.paths.guiIcons">
	    <th>&nbsp;</th>
	    <th>&nbsp;</th>
	    <th colspan="2">"guiIcons":</th>
	    <td colspan="4">
	Directory path to where the gui icons will be loaded relative to DemoKit JSON file path.<br />
	<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="optional">optional</span><br />
	<span class="bold">Default:</span> <span class="string">"gui/icons"</span>
	    </td>
	  </tr>

	  <tr id="demokit.paths.guiStyles" class="odd">
	    <th>&nbsp;</th>
	    <th>&nbsp;</th>
	    <th colspan="2">"guiStyles":</th>
	    <td colspan="4">
	Directory path to where the gui styles will be loaded relative to DemoKit JSON file path.<br />
	<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="optional">optional</span><br />
	<span class="bold">Default:</span> <span class="string">"gui/styles"</span>
	    </td>
	  </tr>

  <tr>
    <th>&nbsp;</th>
    <th colspan="3">},</th>
    <td colspan="4">&nbsp;</td>
  </tr>


  <tr id="demokit.music" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"music":</th>
    <td colspan="4">
Music file to play. Relative to <span class="bold">"paths.music"</span> directory.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="optional">optional</span><br />
<span class="bold">Example:</span> <span class="string">"soundtrack.mp3"</span><br />
<span class="bold">Supported formats:</span> MP3/MP2/MP1/OGG/WAV/AIFF
    </td>
  </tr>

  <tr id="demokit.muted">
    <th>&nbsp;</th>
    <th colspan="3">"muted":</th>
    <td colspan="4">
If the music should be muted.<br />
<span class="bold">Type:</span> <span class="boolean">boolean</span> <span class="optional">optional</span><br />
<span class="bold">Supported values:</span> <span class="boolean">true</span> | <span class="boolean">false</span><span class="default">default</span>
    </td>
  </tr>

  <tr id="demokit.targetFps" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"targetFps":</th>
    <td colspan="4">
FPS which the demo will try to match. Note that if VSync is on then that limit won't be surpassed.<br />
<span class="bold">Type:</span> <span class="number">number</span> <span class="optional">optional</span><br />
<span class="bold">Default:</span> <span class="number">60</span>
    </td>
  </tr>

  <tr id="demokit.playmode">
    <th>&nbsp;</th>
    <th colspan="3">"playmode":</th>
    <td colspan="4">
Mode which the demo player uses after starting. <span class="string">"Production"</span> shows the demo normally. <span class="string">"Development"</span> open up development mode.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.PlayMode">PlayMode</a></span> <span class="optional">optional</span><br />
<span class="bold">Supported values:</span> <span class="string">"Production"</span><span class="default">default</span> | <span class="string">"Development"</span>
    </td>
  </tr>


  <tr id="demokit.debugPlaybackRangeStart" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"debugPlaybackRangeStart":</th>
    <td colspan="4">
Debug playback range start seconds. For development purposes to automatically skip the the defined debug playback range.<br />
<span class="bold">Type:</span> <span class="number">seconds</span> <span class="optional">optional</span><br />
<span class="bold">Default:</span> <span class="number">0</span>
    </td>
  </tr>

  <tr id="demokit.debugPlaybackRangeEnd">
    <th>&nbsp;</th>
    <th colspan="3">"debugPlaybackRangeEnd":</th>
    <td colspan="4">
Debug playback range end seconds. For development purposes to automatically skip the the defined debug playback range.<br />
<span class="bold">Type:</span> <span class="number">seconds</span> <span class="optional">optional</span><br />
<span class="bold">Default:</span> <span class="number">0</span>
    </td>
  </tr>

  <tr id="demokit.loop" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"loop":</th>
    <td colspan="4">
If demo playback should be looped. This will be probably removed in the future as it exists in the setup dialog / command line parameters also.<br />
<span class="bold">Type:</span> <span class="boolean">boolean</span> <span class="optional">optional</span><br />
<span class="bold">Supported values:</span> <span class="boolean">true</span> | <span class="boolean">false</span><span class="default">default</span>
    </td>
  </tr>

  <tr id="demokit.duration">
    <th>&nbsp;</th>
    <th colspan="3">"duration":</th>
    <td colspan="4">
How many seconds the demo will last. Note that currently is the music is shorter then it will loop again from the beginning.<br />
<span class="bold">Type:</span> <span class="number">seconds</span> <span class="optional">optional</span><br />
<span class="bold">Default:</span> <span class="number">180</span>
    </td>
  </tr>

  <tr id="demokit.demoparts" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"demoparts": [</th>
    <td colspan="4">
Array of demo parts.<br />
<span class="bold">Type:</span> <span class="array">array</span> of <span class="object"><a href="#demokit-demopart">demopart</a></span> objects <span class="required">required</span>
    </td>
  </tr>

  <tr class="odd">
    <th>&nbsp;</th>
    <th colspan="3">]</th>
    <td colspan="4">&nbsp;</td>
  </tr>


  <tr>
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>


<h3 id="demokit-demopart">2. Demopart format</h3>

<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr id="demokit.demoparts.name" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"name":</th>
    <td colspan="4">
Name of the demopart.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="required">required</span><br />
<span class="bold">Example:</span> <span class="string">"Good is thy riddle, Gestumblindi"</span>
    </td>
  </tr>

  <tr id="demokit.demoparts.type">
    <th>&nbsp;</th>
    <th colspan="3">"type":</th>
    <td colspan="4">
Type of demopart object. Defines which code the engine will execute for this demopart and whichs params will it parse.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="required">required</span><br />
<span class="bold">Supported values:</span>
  <span class="string">"<a href="#verso.clearscreen">verso.clearscreen</a>"</span>
  | <span class="string line-through">"<a href="#verso.heightmap">verso.heightmap</a>"</span>
  | <span class="string">"<a href="#verso.imageviewer">verso.imageviewer</a>"</span>
  | <span class="string line-through">"<a href="#verso.imguitest">verso.imguitest</a>"</span>
  | <span class="string">"<a href="#verso.particles">verso.particles</a>"</span>
  | <span class="string">"<a href="#verso.randombackground">verso.randombackground</a>"</span>
  | <span class="string line-through">"<a href="#verso.scenegraph">verso.scenegraph</a>"</span>
  | <span class="string">"<a href="#verso.shadertoy">verso.shadertoy</a>"</span>
  | <span class="string line-through">"<a href="#verso.verso-3dtest">verso.verso-3dtest</a>"</span>
    </td>
  </tr>

  <tr id="demokit.demoparts.start" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"start":</th>
    <td colspan="4">
Time in seconds when the demopart will start playing.<br />
<span class="bold">Type:</span> <span class="number">seconds</span> <span class="required">required</span><br />
<span class="bold">Example:</span> <span class="number">2.52</span>
    </td>
  </tr>

  <tr id="demokit.demoparts.duration">
    <th>&nbsp;</th>
    <th colspan="3">"duration":</th>
    <td colspan="4">
How many seconds the demopart will last. Note that playback will be capped to global duration even if there are demoparts longer than it.<br />
<span class="bold">Type:</span> <span class="number">seconds</span> <span class="required">required</span><br />
<span class="bold">Example:</span> <span class="number">12.45</span>
    </td>
  </tr>

  <tr id="demokit.demoparts.priority" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"priority":</th>
    <td colspan="4">
Render priority. When there are several demoparts active at the same time the demopart with bigger priority will be rendered after the demopart with the lower priority.<br />
<span class="bold">Type:</span> <span class="number">integer number</span> <span class="required">required</span><br />
<span class="bold">Example:</span> <span class="number">3</span>
    </td>
  </tr>

  <tr id="demokit.demoparts.params">
    <th>&nbsp;</th>
    <th colspan="3">"params": {</th>
    <td colspan="4">
Object containing custom parameters for the chosen demopart type. Even is demopart doesn't take any parameters you must at least define an empty object, e.g. "params": {}<br />
<span class="bold">Type:</span> object <span class="required">required</span>
    </td>
  </tr>

  <tr>
    <th>&nbsp;</th>
    <th colspan="3">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>


<h3 id="verso.clearscreen">2.1. verso.clearscreen params</h3>
<p>ClearScreen clears the screen color and/or depth buffer.</p>
<table>
  <tr>
    <th colspan="8">{ ..., "type": <span class="string">"verso.clearscreen"</span>, ..., "params": {</th>
  </tr>

  <tr id="verso.clearscreen.clear" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"clear": {</th>
    <td colspan="4">
Set how to clear the screen.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.ClearParam">ClearParam</a></span><span class="optional">optional</span><br />
<span class="bold">Default:</span> Clear screen with <span class="string">"SolidColor"</span> and color [ <span class="number">0.2235</span>, <span class="number">0.2235</span>, <span class="number">0.2235</span> ].
    </td>
  </tr>

  <tr class="odd">
    <th>&nbsp;</th>
    <th colspan="3">},</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr>
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>

<h4>Example: Clear screen with default color</h4>
<pre><code class="json">
    { "<a href="#demokit.demoparts.name">name</a>": "Clear", "<a href="#demokit.demoparts.type">type</a>": "verso.clearscreen",
      "<a href="#demokit.demoparts.start">start</a>": 0, "<a href="#demokit.demoparts.duration">duration</a>": 3000, "<a href="#demokit.demoparts.priority">priority</a>": 0, "<a href="#demokit.demoparts.params">params</a>": {
    }},
</code></pre>

<h4>Example: Clear screen with custom color</h4>
<pre><code class="json">
    { "<a href="#demokit.demoparts.name">name</a>": "Clear", "<a href="#demokit.demoparts.type">type</a>": "verso.clearscreen",
      "<a href="#demokit.demoparts.start">start</a>": 0, "<a href="#demokit.demoparts.duration">duration</a>": 3000, "<a href="#demokit.demoparts.priority">priority</a>": 0, "<a href="#demokit.demoparts.params">params</a>": {
         "<a href="#verso.clearscreen.clear">clear</a>": {
             "<a href="#types.Color">color</a>": [1, 0, 1]
         }
    }},
</code></pre>

<h4>Example: Clear screen with custom color but don't clear the Z buffer</h4>
<pre><code class="json">
    { "<a href="#demokit.demoparts.name">name</a>": "Clear", "<a href="#demokit.demoparts.type">type</a>": "verso.clearscreen",
      "<a href="#demokit.demoparts.start">start</a>": 0, "<a href="#demokit.demoparts.duration">duration</a>": 3000, "<a href="#demokit.demoparts.priority">priority</a>": 0, "<a href="#demokit.demoparts.params">params</a>": {
         "<a href="#verso.clearscreen.clear">clear</a>": {
             "<a href="#types.Color">color</a>": [1, 0, 1],
             "<a href="#types.ClearFlag">clearFlag</a>": "ColorBuffer"
         }
    }},
</code></pre>


<h3 id="verso.heightmap" class="line-through">2.2. verso.heightmap params</h3>

<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>


<h3 id="verso.imageviewer">2.3. verso.imageviewer params</h3>
<p>ImageViewer show a given image on the screen and optionally clears the screen.</p>
<table>
  <tr>
    <th colspan="8">{ ..., "type": <span class="string">"verso.imageviewer"</span>, ..., "params": {</th>
  </tr>

  <tr id="verso.imageviewer.source" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"source":</th>
    <td colspan="4">
Image file name to show. Relative to <span class="bold">"paths.textures"</span> directory.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="required">required</span><br />
<span class="bold">Example:</span> <span class="string">"goonies.png"</span><br />
<span class="bold">Supported file extensions:</span> <span class="string">.jpg</span> | <span class="string">.jpeg</span> | <span class="string">.png</span> | <span class="string">.tga</span> | <span class="string">.bmp</span> | <span class="string">.psd</span> | <span class="string">.gif</span> | <span class="string">.hdr</span> | <span class="string">.pic</span> | <span class="string">.pnm</span>
    </td>
  </tr>

  <tr id="verso.imageviewer.clear">
    <th>&nbsp;</th>
    <th colspan="3">"clear": {</th>
    <td colspan="4">
Set how to clear the screen.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.ClearParam">ClearParam</a></span><span class="optional">optional</span><br />
<span class="bold">Default:</span> Do not clear the screen.
    </td>
  </tr>
  <tr>
    <th>&nbsp;</th>
    <th colspan="3">},</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr id="verso.imageviewer.align" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"align": {</th>
    <td colspan="4">
Align the image on the screen. <span class="string">"Undefined"</span> means that image won't be aligned on that axis.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.Align">Align</a></span><span class="optional">optional</span><br />
<span class="bold">Default:</span> { "horizontal": <span class="string">"Undefined"</span>, "vertical": <span class="string">"Undefined"</span> }
    </td>
  </tr>
  <tr class="odd">
    <th>&nbsp;</th>
    <th colspan="3">},</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr id="verso.imageviewer.relative">
    <th>&nbsp;</th>
    <th colspan="3">"relative":</th>
    <td colspan="4">
Translate and/or scale the image relative to screen width and height.<br />
For translation: Top-Left = (<span class="number">0.0</span>, <span class="number">0.0</span>), Bottom-right = (<span class="number">1.0</span>, <span class="number">1.0</span>)<br />
For scaling: <span class="number">0.0</span>=zero size <span class="number">1.0</span>=full screen width/height.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.Rectf">Rectf</a></span><span class="optional">optional</span><br />
<span class="bold">Default:</span> { "x": <span class="number">0</span>, "y": <span class="number">0</span>, "width": <span class="number">0</span>, "height": <span class="number">0</span> }
    </td>
  </tr>

  <tr id="verso.imageviewer.aspectRatioFix" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"aspectRatioFix":</th>
    <td colspan="4">
If <span class="boolean">true</span> then use image aspect ratio when scaling.<br />
<span class="bold">Type:</span> <span class="boolean"><a href="#types.boolean">boolean</a></span> <span class="optional">optional</span><br />
<span class="bold">Default:</span> <span class="boolean">true</span>
    </td>
  </tr>

  <tr id="verso.imageviewer.rotation">
    <th>&nbsp;</th>
    <th colspan="3">"rotation":</th>
    <td colspan="4">
Rotate the image in given angle in degrees.<br />
<span class="bold">Type:</span> <span class="number"><a href="#types.number">number</a></span> <span class="optional">optional</span><br />
<span class="bold">Default:</span> 0.0
    </td>
  </tr>

  <tr id="verso.imageviewer.blend" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"blend":</th>
    <td colspan="4">
Which BlendMode to use for rendering the image.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.BlendMode">BlendMode</a></span> <span class="optional">optional</span><br />
<span class="bold">Default:</span> <span class="string">"Transcluent"</span>
    </td>
  </tr>

  <tr id="verso.imageviewer.alpha">
    <th>&nbsp;</th>
    <th colspan="3">"alpha":</th>
    <td colspan="4">
Global alpha value for the image which is multiplied with the image pixels' alpha values. Note that the effect requires a suitable BlendMode to be set. Value is between [<span class="number">0.0</span>..<span class="number">1.0</span>]. <span class="number">0.0</span> = fully transparent, <span class="number">1.0</span> = fully visible.<br />
<span class="bold">Type:</span> <span class="number"><a href="#types.number">number</a></span> <span class="optional">optional</span><br />
<span class="bold">Default:</span> <span class="number">1.0</span>
    </td>
  </tr>

  <tr id="verso.imageviewer.minfilter" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"minfilter":</th>
    <td colspan="4">
Which minification filter to use when scaling the image down from it's original resolution.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.MinFilter">MinFilter</a></span> <span class="optional">optional</span><br />
<span class="bold">Default:</span> <span class="string">"Linear"</span>
    </td>
  </tr>

  <tr id="verso.imageviewer.magfilter">
    <th>&nbsp;</th>
    <th colspan="3">"magfilter":</th>
    <td colspan="4">
Which magnication filter to use when scaling the image up from it's original resolution.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.MagFilter">MagFilter</a></span> <span class="optional">optional</span><br />
<span class="bold">Default:</span> <span class="string">"Linear"</span>
    </td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>

<h4>Example: Show image with default settings</h4>
<pre><code class="json">
    { "<a href="#demokit.demoparts.name">name</a>": "My image", "<a href="#demokit.demoparts.type">type</a>": "verso.imageviewer",
      "<a href="#demokit.demoparts.start">start</a>": 0, "<a href="#demokit.demoparts.duration">duration</a>": 3000, "<a href="#demokit.demoparts.priority">priority</a>": 0, "<a href="#demokit.demoparts.params">params</a>": {
         "<a href="#verso.imageviewer.source">source</a>": "quote.png"</span>
    }},
</code></pre>

<h4>Example: Render acid logo with</h4>
<ul>
  <li>0.25x transcluent</li>
  <li>scaled 0.1x height</li>
  <li>aspect ratio fixed scaling</li>
  <li>aligned Bottom-Right</li>
  <li>with 45 degree rotation</li>
  <li>"pixeled" magnification.</li>
</ul>
<pre><code class="json">
    { "<a href="#demokit.demoparts.name">name</a>": "aciid1", "<a href="#demokit.demoparts.type">type</a>": "verso.imageviewer",
      "<a href="#demokit.demoparts.start">start</a>": 0, "<a href="#demokit.demoparts.duration">duration</a>": 3000, "<a href="#demokit.demoparts.priority">priority</a>": 0, "<a href="#demokit.demoparts.params">params</a>": {
         "<a href="#verso.imageviewer.source">source</a>": "acid.png"</span>,
         "<a href="#verso.imageviewer.align">align</a>": {
             "<a href="#types.Align">horizontal</a>": "Right",
             "<a href="#types.Align">vertical</a>": "Bottom"
         },
         "<a href="#verso.imageviewer.relative">relative</a>": {
             "<a href="#types.Rectf">height</a>": 0.1
         },
         "<a href="#verso.imageviewer.aspectRatioFix">aspectRatioFix</a>": true,
         "<a href="#verso.imageviewer.rotation">rotation</a>": 45,
         "<a href="#verso.imageviewer.blend">blend</a>": "Transcluent",
         "<a href="#verso.imageviewer.alpha">alpha</a>": 0.25,
         "<a href="#verso.imageviewer.magfilter">magfilter</a>": "Nearest"
    }},
</code></pre>

<h4>Example: Render acid logo with</h4>
<ul>
  <li>screen & depth buffer cleared to color [0.45, 0.56, 0.60, 1]</li>
  <li>aligned Top-Left</li>
  <li>scaled 0.4x width and relative screen position of 0.1x width and 0.01x height</li>
  <li>with 210 degree rotation</li>
  <li>0.7x transcluent</li>
</ul>
<pre><code class="json">
    { "<a href="#demokit.demoparts.name">name</a>": "aciid2", "<a href="#demokit.demoparts.type">type</a>": "verso.imageviewer",
      "<a href="#demokit.demoparts.start">start</a>": 0, "<a href="#demokit.demoparts.duration">duration</a>": 3000, "<a href="#demokit.demoparts.priority">priority</a>": 0, "<a href="#demokit.demoparts.params">params</a>": {
         "<a href="#verso.imageviewer.clear">clear</a>": {
             "<a href="#types.Color">color</a>": [0.45, 0.56, 0.60, 1],
             "<a href="#types.ClearFlag">clearFlag</a>": "SolidColor"
         },
         "<a href="#verso.imageviewer.source">source</a>": "acid.png"</span>,
         "<a href="#verso.imageviewer.align">align</a>": {
             "<a href="#types.Align">horizontal</a>": "Left",
             "<a href="#types.Align">vertical</a>": "Top"
         },
         "<a href="#verso.imageviewer.relative">relative</a>": {
             "<a href="#types.Rectf">x</a>": 0.1,
             "<a href="#types.Rectf">y</a>": 0.01,
             "<a href="#types.Rectf">width</a>": 0.4
         },
         "<a href="#verso.imageviewer.rotation">rotation</a>": 210,
         "<a href="#verso.imageviewer.blend">blend</a>": "Transcluent",
         "<a href="#verso.imageviewer.alpha">alpha</a>": 0.7
    }},
</code></pre>


<h3 id="verso.imguitest" class="line-through">2.4. verso.imguitest params</h3>

<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>


<h3 id="verso.particles">2.5. verso.particles params</h3>

<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr id="verso.particles.particles" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"particles": {</th>
    <td colspan="4">
Defines a particle system.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.ParticlesParam">ParticlesParam</a></span><span class="required">required</span><br />
    </td>
  </tr>
  <tr class="odd">
    <th>&nbsp;</th>
    <th colspan="3">},</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr id="verso.particles.behaviour" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"behaviour": {</th>
    <td colspan="4">
Defines how particles react when time goes on.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.BehaviourParam">BehaviourParam</a></span><span class="required">required</span><br />
    </td>
  </tr>
  <tr class="odd">
    <th>&nbsp;</th>
    <th colspan="3">},</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr id="verso.particles.emitter" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"emitter": {</th>
    <td colspan="4">
Defines what kind of particles are emitted.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.EmitterParam">EmitterParam</a></span><span class="required">required</span><br />
    </td>
  </tr>
  <tr class="odd">
    <th>&nbsp;</th>
    <th colspan="3">},</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr id="verso.particles.sequencer" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"sequencer": {</th>
    <td colspan="4">
Defines when and how many particles are emitted.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.SequencerParam">SequencerParam</a></span><span class="required">required</span><br />
    </td>
  </tr>
  <tr class="odd">
    <th>&nbsp;</th>
    <th colspan="3">},</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>


<h3 id="verso.randombackground">2.6. verso.randombackground params</h3>

<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr id="verso.randombackground.sourcePath" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"sourcePath":</th>
    <td colspan="4">
Directory path where a random image is chosen during load. Relative to <span class="bold">"paths.textures"</span> directory.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="optional">optional</span><br />
<span class="bold">Default:</span> <span class="bold">"paths.textures"</span> directory<br />
<span class="bold">Example:</span> <span class="string">"some/directory"</span><br />
<span class="bold">Supported file extensions:</span> <span class="string">.jpg</span> | <span class="string">.jpeg</span> | <span class="string">.png</span> | <span class="string">.tga</span> | <span class="string">.bmp</span> | <span class="string">.psd</span> | <span class="string">.gif</span> | <span class="string">.hdr</span> | <span class="string">.pic</span> | <span class="string">.pnm</span>
    </td>
  </tr>

  <tr id="verso.randombackground.clear">
    <th>&nbsp;</th>
    <th colspan="3">"clear": {</th>
    <td colspan="4">
Set how to clear the screen.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.ClearParam">ClearParam</a></span><span class="optional">optional</span><br />
<span class="bold">Default:</span> Clear screen with <span class="string">"SolidColor"</span> and color [ <span class="number">0.2235</span>, <span class="number">0.2235</span>, <span class="number">0.2235</span> ].
    </td>
  </tr>
  <tr>
    <th>&nbsp;</th>
    <th colspan="3">},</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>

<h4>Example: Simple random background</h4>
<p>Clear screen with default color and show random background from backgrounds directory relative to <span class="bold">"paths.textures"</span> directory.</p>
<pre><code class="json">
    { "<a href="#demokit.demoparts.name">name</a>": "My image", "<a href="#demokit.demoparts.type">type</a>": "verso.randombackground",
      "<a href="#demokit.demoparts.start">start</a>": 0, "<a href="#demokit.demoparts.duration">duration</a>": 3000, "<a href="#demokit.demoparts.priority">priority</a>": 0, "<a href="#demokit.demoparts.params">params</a>": {
         "<a href="#verso.randombackground.sourcePath">sourcePath</a>": "backgrounds"</span>
    }},
</code></pre>

<h4>Example: Simple random background with custom clear color</h4>
<p>Clear screen with color [ 1, 0.5, 0.5 ] and show random background from backgrounds directory relative to <span class="bold">"paths.textures"</span> directory.</p>
<pre><code class="json">
    { "<a href="#demokit.demoparts.name">name</a>": "My image", "<a href="#demokit.demoparts.type">type</a>": "verso.randombackground",
      "<a href="#demokit.demoparts.start">start</a>": 0, "<a href="#demokit.demoparts.duration">duration</a>": 3000, "<a href="#demokit.demoparts.priority">priority</a>": 0, "<a href="#demokit.demoparts.params">params</a>": {
         "<a href="#verso.randombackground.sourcePath">sourcePath</a>": "backgrounds"</span>,
         "<a href="#verso.randombackground.clear">clear</a>": {
             "<a href="#types.ClearParam">color</a>": [ 1, 0.5, 0.5 ]
         }
    }},
</code></pre>


<h3 id="verso.scenegraph" class="line-through">2.7. verso.scenegraph params</h3>

<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>


<h3 id="verso.shadertoy">2.8. verso.shadertoy params</h3>

<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr id="verso.shadertoy.shader" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"shader": {</th>
    <td colspan="4">
Set shadertoy compatible shader to use.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.ShaderParam">ShaderParam</a></span><span class="optional">optional</span><br />
<span class="bold">Default:</span> { "frag": <span class="string">"shadertoy/shadertoy.default.330.frag"</span>, "vert": <span class="string">"shadertoy/shadertoy.default.330.vert"</span> }
    </td>
  </tr>
  <tr class="odd">
    <th>&nbsp;</th>
    <th colspan="3">},</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr id="verso.shadertoy.channel">
    <th>&nbsp;</th>
    <th colspan="3">"channel": {</th>
    <td colspan="4">
Set shadertoy channels. List of file names to textures relative to <span class="bold">"paths.textures"</span> directory.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.ChannelParam">ChannelParam</a></span><span class="optional">optional</span><br />
<span class="bold">Default:</span> []<br />
<span class="bold">Supported file extensions:</span> <span class="string">.jpg</span> | <span class="string">.jpeg</span> | <span class="string">.png</span> | <span class="string">.tga</span> | <span class="string">.bmp</span> | <span class="string">.psd</span> | <span class="string">.gif</span> | <span class="string">.hdr</span> | <span class="string">.pic</span> | <span class="string">.pnm</span> | animation <span class="bold">TODO</span> | video files <span class="bold">TODO</span>

    </td>
  </tr>
  <tr>
    <th>&nbsp;</th>
    <th colspan="3">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>


  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>

<h4>Example: Simple vortex effect</h4>
<p>Shows a Shadertoy converted simple vortex effect.</p>
<pre><code class="json">
    { "<a href="#demokit.demoparts.name">name</a>": "2d vortex effect test", "<a href="#demokit.demoparts.type">type</a>": "verso.shadertoy",
      "<a href="#demokit.demoparts.start">start</a>": 0, "<a href="#demokit.demoparts.duration">duration</a>": 3000, "<a href="#demokit.demoparts.priority">priority</a>": 0, "<a href="#demokit.demoparts.params">params</a>": {
        "<a href="#verso.shadertoy.shader">shader</a>": { "<a href="#types.ShaderParam">frag</a>": "shadertoy/external/simple_vortex_effect_2d_by_public_int_i.frag" },
        "<a href="#verso.shadertoy.channel">channel</a>": [ "shadertoy/tex07.jpg", "shadertoy/tex07.jpg" ] }}
    }},
</code></pre>

<h4>Example: Simple eye blower</h4>
<p>Shows a Shadertoy converted simple eye blower effect.</p>
<pre><code class="json">
    { "<a href="#demokit.demoparts.name">name</a>": "Interference shader test", "<a href="#demokit.demoparts.type">type</a>": "verso.shadertoy",
      "<a href="#demokit.demoparts.start">start</a>": 0, "<a href="#demokit.demoparts.duration">duration</a>": 3000, "<a href="#demokit.demoparts.priority">priority</a>": 0, "<a href="#demokit.demoparts.params">params</a>": {
        "<a href="#verso.shadertoy.shader">shader</a>": { "<a href="#types.ShaderParam">frag</a>": "shadertoy/external/simple_eye_blower_by_lanza.frag" }
    }},
</code></pre>


<h3 id="verso.verso-3dtest" class="line-through">2.9. verso.verso-3dtest params</h3>

<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>



<h2 id="types">3. Types</h2>


<h3 id="types.null">3.1. null type</h3>
<table>
  <tr>
    <td>
<span class="null">null</span> is a JSON basic type which indicates that value does not exist, is unset or empty.<br />
<span class="bold">Type:</span> <span class="null"><a href="#types.null">null</a></span><br />
<span class="bold">Supported values:</span> <span class="null">null</span>
    </td>
  </tr>
</table>


<h3 id="types.object">3.2. object type</h3>
<table>
  <tr>
    <td>
<span class="object">object</span> is a JSON basic type which consists of any number of fields inside curly brackets.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.object">object</a></span><br />
<span class="bold">Examples:</span> {} | { "some field": <span class="string">"some value"</span> } | { "some field": <span class="string">"some value"</span>, "another field": <span class="number">100</span> }
    </td>
  </tr>
</table>


<h3 id="types.array">3.3. array type</h3>
<table>
  <tr>
    <td>
<span class="array">array</span> is a JSON basic type which consists of zero or more values inside square brackets.<br />
<span class="bold">Type:</span> <span class="array"><a href="#types.array">array</a></span><br />
<span class="bold">Examples:</span> [] | [<span class="string">"first"</span>, <span class="string">"second"</span>] | [<span class="number">1.0</span>, <span class="number">2</span>, <span class="number">3.5</span>]
    </td>
  </tr>
</table>


<h3 id="types.boolean">3.4. boolean type</h3>
<table>
  <tr>
    <td>
<span class="boolean">boolean</span> is a JSON basic type which is either <span class="boolean">true</span> or <span class="boolean">false</span>.<br />
<span class="bold">Type:</span> <span class="boolean"><a href="#types.boolean">boolean</a></span><br />
<span class="bold">Supported values:</span> <span class="boolean">true</span> | <span class="boolean">false</span>
    </td>
  </tr>
</table>


<h3 id="types.number">3.5. number type</h3>
<table>
  <tr>
    <td>
<span class="number">number</span> is a JSON basic type which can be any number.<br />
<span class="bold">Type:</span> <span class="number"><a href="#types.number">number</a></span><br />
<span class="bold">Examples:</span> <span class="number">0</span> | <span class="number">-5</span> | <span class="number">5.0</span> | <span class="number">0.2452</span>
    </td>
  </tr>
</table>


<h3 id="types.integer">3.6. integer number type</h3>
<table>
  <tr>
    <td>
<span class="number">integer</span> isn't a JSON basic type but a custom type in DemoKit for values that cannot contain decimals. If decimals are given to an integer value then they're floored (removed) and warning is printed out.<br />
<span class="bold">Type:</span> <span class="number"><a href="#types.integer">integer</a></span><br />
<span class="bold">Examples:</span> <span class="number">0</span> | <span class="number">-5</span> | <span class="number">5.0</span> | <span class="number">0.9222</span> (will be floored to 0 with a warning)
    </td>
  </tr>
</table>


<h3 id="types.string">3.7. string type</h3>
<table>
  <tr>
    <td>
<span class="string"><a href="#types.string">string</a></span> is a JSON basic type which is sequence of zero or more characters inside double quotation marks.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span><br />
<span class="bold">Examples:</span> <span class="string">""</span> | <span class="string">"asdf"</span> | <span class="string">"Some words..."</span>
    </td>
  </tr>
</table>


<h3 id="types.Align">3.8. Align type</h3>
<table>
  <tr>
    <td>
<span class="object">Align</span> defines how something should be aligned. It's an object containing two fields: "horizontal"<span class="optional">optional</span> and "vertical"<span class="optional">optional</span>.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.object">object</a></span><br />
<span class="bold">Possible values for "horizontal":</span> <span class="string">"Left"</span> | <span class="string">"Center"</span> | <span class="string">"Right"</span> | <span class="string">"Undefined"</span><br />
<span class="bold">Possible values for "vertical":</span> <span class="string">"Top"</span> | <span class="string">"Center"</span> | <span class="string">"Bottom"</span> | <span class="string">"Undefined"</span><br />
<span class="bold">Examples:</span> {} | {"horizontal": <span class="string">"Center"</span>} | {"horizontal": <span class="string">"Left"</span>, "vertical": <span class="string">"Bottom"</span>}
    </td>
  </tr>
</table>


<h3 id="types.Color">3.9. Color type</h3>
<table>
  <tr>
    <td>
<span class="object">Color</span> defines a RGB or RGBA color. It's an array containing 3-4 number values between 0 and 1. For color components 1 means full color and zero no color, for alpha 0 means full transparency and 1 no transparency. <span class="bold">TODO:</span> support for <span class="string">"#rrggbbaa"</span> values.<br />
<span class="bold">Type:</span> <span class="array"><a href="#types.array">array</a></span> of 3 or 4 <span class="number"><a href="#types.number">numbers</a></span></span><br />
<span class="bold">Examples:</span> [<span class="number">0</span>, <span class="number">1</span>, <span class="number">0</span>] | [<span class="number">0.52</span>, <span class="number">0</span>, <span class="number">0.62</span>, <span class="number">0.5</span>]
    </td>
  </tr>
</table>


<h3 id="types.Rangef">3.10. Rangef type</h3>
<table>
  <tr>
    <td>
<span class="object">Rangef</span> defines a range of <span class="array"><a href="#types.array">numbers</a></span> between given a and b inside an <span class="array"><a href="#types.array">array</a></span>.<br />
<span class="bold">Type:</span> <span class="array"><a href="#types.array">array</a></span> of two <span class="number"><a href="#types.number">numbers</a></span><br />
<span class="bold">Examples:</span> [<span class="number">0</span>, <span class="number">2</span>] | [<span class="number">-5.2</span>, <span class="number">25.9</span>]
    </td>
  </tr>
</table>


<h3 id="types.Rectf">3.11. Rectf type</h3>
<table>
  <tr>
    <td>
<span class="object">Rectf</span> defines a rectangle. It's and object containing four <span class="number"><a href="#types.number">number</a></span> fields: "x"<span class="optional">optional</span>, "y"<span class="optional">optional</span>, "width"<span class="optional">optional</span> and "height"<span class="optional">optional</span>. "x" and "y" defines the top-left point for the rectangle and "width" and "height" the size. <span class="bold">TODO:</span> add support for <span class="array"><a href="#types.array">array</a></span> of four values.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.object">object</a></span><br />
<span class="bold">Examples:</span> {} | {"x": <span class="number">1.5</span>, "y": <span class="number">2</span>, "width": <span class="number">5</span>, "height": <span class="number">10</span>}
    </td>
  </tr>
</table>


<h3 id="types.Vector2f">3.12. Vector2f type</h3>
<table>
  <tr>
    <td>
<span class="object">Vector2f</span> defines a two-dimensional vector. It's and object containing two <span class="number"><a href="#types.number">number</a></span> fields: "x"<span class="optional">optional</span>, "y"<span class="optional">optional</span>. "x" and "y" defines the point for the vector. This can be used depending on the context as a (x,y) position in space or a direction from origo (0,0) to (x,y). <span class="bold">TODO:</span> add support for <span class="array"><a href="#types.array">array</a></span> of two values.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.object">object</a></span><br />
<span class="bold">Examples:</span> {} | {"x": <span class="number">1.5</span>, "y": <span class="number">2</span>}
    </td>
  </tr>
</table>


<h3 id="types.Vector2i">3.13. Vector2i type</h3>
<table>
  <tr>
    <td>
<span class="object">Vector2i</span> defines a two-dimensional vector. It's and object containing two <span class="number"><a href="#types.integer">integer numbers</a></span> fields: "x"<span class="optional">optional</span>, "y"<span class="optional">optional</span>. "x" and "y" defines the point for the vector. This can be used depending on the context as a (x,y) position in space or a direction from origo (0,0) to (x,y). <span class="bold">TODO:</span> add support for <span class="array"><a href="#types.array">array</a></span> of two values.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.object">object</a></span><br />
<span class="bold">Examples:</span> {} | {"x": <span class="number">1</span>, "y": <span class="number">2</span>} | {"x": <span class="number">1.9</span>, "y": <span class="number">-2.2</span>} (will be floored to (<span class="number">1</span>, <span class="number">-2</span> with a warning))
    </td>
  </tr>
</table>


<h3 id="types.Vector3f">3.14. Vector3f type</h3>
<table>
  <tr>
    <td>
<span class="object">Vector3f</span> defines a three-dimensional vector. It's and object containing three <span class="number"><a href="#types.number">number</a></span> fields: "x"<span class="optional">optional</span>, "y"<span class="optional">optional</span>, "z"<span class="optional">optional</span>. "x", "y" and "z" defines the point for the vector. This can be used depending on the context as a (x,y,z) position in space or a direction from origo (0,0) to (x,y,z). <span class="bold">TODO:</span> add support for <span class="array"><a href="#types.array">array</a></span> of three values.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.object">object</a></span><br />
<span class="bold">Examples:</span> {} | {"x": <span class="number">1.5</span>, "y": <span class="number">2</span>, "y": <span class="number">-3</span>}
    </td>
  </tr>
</table>


<h3 id="types.BlendMode">3.15. BlendMode type</h3>
<table>
  <tr>
    <td>
<span class="object">BlendMode</span> defines which blend mode to use for rendering.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span><br />
<span class="bold">Supported values:</span>
<ul>
  <li><span class="string">"None"</span> = No blending used. This also means that there's not alpha transparency.</li>
  <li><span class="string">"Transcluent"</span> = Trancluenct blending i.e. combines colors with multiplication.</li>
  <li><span class="string">"Additive"</span> = Additive blending i.e. lightens the image under.</li>
  <li><span class="string">"Subtractive"</span> = Subtractive blending i.e. darkens the image under.</li>
  <li><span class="string">"ReverseSubtractive"</span> = Subtractive blending that works with alpha transparency i.e. darkens the image under.</li>
</ul>
    </td>
  </tr>
</table>


<h3 id="types.ClearFlag">3.16. ClearFlag type</h3>
<table>
  <tr>
    <td>
<span class="object">ClearFlag</span> defines the way screen should be cleared.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span><br />
<span class="bold">Supported values:</span>
<ul>
  <li><span class="string">"None"</span> = Do no clear.</li>
  <li><span class="string">"ColorBuffer"</span> = Clears only the color buffer but not the depth buffer.</li>
  <li><span class="string">"DepthBuffer"</span> = Clears only the depth buffer but not the color buffer.</li>
  <li><span class="string">"SolidColor"</span> = Clears both color and depth buffers with a solid color.</li>
  <li><span class="string line-through">"Skybox"</span> = Clears both color and depth buffers with a skybox. <span class="bold">TODO:</span> Not implemented.</li>
</ul>
    </td>
  </tr>
</table>


<h3 id="types.MinFilter">3.17. MinFilter type</h3>
<table>
  <tr>
    <td>
<span class="object">MinFilter</span> defines how texture is scaled down. The texture minifying function is used whenever the pixel being textured maps to an area greater than one texture element.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span><br />
<span class="bold">Supported values:</span>
<ul>
  <li><span class="string">"Nearest"</span> = Returns the value of the texture element that is nearest (in Manhattan distance) to the specified texture coordinates.</li>
  <li><span class="string">"Linear"</span> = Returns the weighted average of the four texture elements that are closest to the specified texture coordinates. These can include items wrapped or repeated from other parts of a texture, depending on the values of GL_TEXTURE_WRAP_S and GL_TEXTURE_WRAP_T, and on the exact mapping.</li>
  <li><span class="string">"NearestMipmapNearest"</span> = Chooses the mipmap that most closely matches the size of the pixel being textured and uses the <span class="string">"Nearest"</span> criterion (the texture element closest to the specified texture coordinates) to produce a texture value.</li>
  <li><span class="string">"LinearMipmapNearest"</span> = Chooses the mipmap that most closely matches the size of the pixel being textured and uses the <span class="string">"Linear"</span> criterion (a weighted average of the four texture elements that are closest to the specified texture coordinates) to produce a texture value.</li>
  <li><span class="string">"NearestMipmapLinear"</span> = Chooses the two mipmaps that most closely match the size of the pixel being textured and uses the <span class="string">"Nearest"</span> criterion (the texture element closest to the specified texture coordinates ) to produce a texture value from each mipmap. The final texture value is a weighted average of those two values.</li>
  <li><span class="string">"LinearMipmapLinear"</span> = Chooses the two mipmaps that most closely match the size of the pixel being textured and uses the <span class="string">"Linear"</span> criterion (a weighted average of the texture elements that are closest to the specified texture coordinates) to produce a texture value from each mipmap. The final texture value is a weighted average of those two values.</li>
  <li><span class="string">"Default"</span> = same as <span class="string">"NearestMipmapLinear"</span></li>
</ul>
<span class="bold">Default:</span> <span class="string">"NearestMipmapLinear"</span>
    </td>
  </tr>
</table>


<h3 id="types.MagFilter">3.18. MagFilter type</h3>
<table>
  <tr>
    <td>
<span class="object">MagFilter</span> defines how texture is scaled up. The texture magnification function is used when the pixel being textured maps to an area less than or equal to one texture element.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span><br />
<span class="bold">Supported values:</span>
<ul>
  <li><span class="string">"Nearest"</span> = Returns the value of the texture element that is nearest (in Manhattan distance) to the specified texture coordinates.</li>
  <li><span class="string">"Linear"</span> = Returns the weighted average of the texture elements that are closest to the specified texture coordinates. These can include items wrapped or repeated from other parts of a texture, depending on the values of GL_TEXTURE_WRAP_S and GL_TEXTURE_WRAP_T, and on the exact mapping.</li>
  <li><span class="string">"Default"</span> = same as <span class="string">"Linear"</span>
</ul>
<span class="bold">Default:</span> <span class="string">"Linear"</span>
    </td>
  </tr>
</table>


<h3 id="types.PlayMode">3.19. PlayMode type</h3>
<table>
  <tr>
    <td>
Playmode is a enum like <span class="string"><a href="#types.string">string</a></span> with two possible values.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span><br />
<span class="bold">Supported values:</span> <span class="string">"Production"</span> | <span class="string">"Development"</span>
    </td>
  </tr>
</table>


<h3 id="types.CameraTimeline">3.20. CameraTimeline type</h3>
<table>
  <tr>
    <td>
TODO<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.TODO">TODO</a></span><br />
<span class="bold">Supported values:</span> TODO
    </td>
  </tr>
</table>


<h3 id="types.BehaviourParam">3.21. BehaviourParam type</h3>
<p>Defines how particles react when time goes on.</p>
<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr id="verso.BehaviourParam.type" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"type":</th>
    <td colspan="4">
Choose the type of behaviour to use.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="required">required</span><br />
    </td>
  </tr>

  <tr>
    <th>&nbsp;</th>
    <th colspan="3">"..."</th>
    <td colspan="4">
<span class="bold">Other parameters are dependent on the type.</span><br />
    </td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>


<h4 id="types.BehaviourParam.type=SimpleGravity">3.21.1. BehaviourParam.type="SimpleGravity"</h4>
<p>SimpleGravity defines a behaviour which applied a simple gravity to particles.</p>
<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"type":</th>
    <td colspan="4">
<span class="string">"SimpleGravity"</span>
    </td>
  </tr>

  <tr id="verso.BehaviourParam.type=SimpleGravity.TODO">
    <th>&nbsp;</th>
    <th colspan="3">"TODO"</th>
    <td colspan="4">
<span class="bold">TODO</span>
    </td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>


<h3 id="types.ChannelParam">3.22. ChannelParam type</h3>
<table>
  <tr>
    <td>
<span class="string">ChannelParam</span> is a list of channel texture file names in defined order.<br />
<span class="bold">Type:</span> <span class="array"><a href="#types.array">array</a></span><br />
    </td>
  </tr>
</table>


<h3 id="types.ClearParam">3.23. ClearParam type</h3>
<table>
  <tr>
    <td>
<span class="string">ClearParam</span> defines how the screen should be cleared. It is an object with two fields <span class="string">"clearFlag"</span><span class="optional">optional</span> and <span class="string">"color"</span><span class="optional">optional</span>.<br />
<span class="bold">Type:</span> <span class="object"><a href="#types.object">object</a></span><br />
<ul>
  <li>"clearFlag": <span class="object"><a href="#types.ClearFlag">ClearFlag</a></span> (default: <span class="string">"SolidColor"</span>)</li>
  <li>"color": <span class="object"><a href="#types.Color">Color</a></span> (default: [ <span class="number">0.2235</span>, <span class="number">0.2235</span>, <span class="number">0.2235</span> ])</li>
</ul>
    </td>
  </tr>
</table>


<h3 id="types.EmitterParam">3.24. EmitterParam type</h3>
<p>Defines what kind of particles are emitted.</p>
<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr id="verso.EmitterParam.type" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"type":</th>
    <td colspan="4">
Choose the type of emitter to use.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="required">required</span><br />
    </td>
  </tr>

  <tr>
    <th>&nbsp;</th>
    <th colspan="3">"..."</th>
    <td colspan="4">
<span class="bold">Other parameters are dependent on the type.</span><br />
    </td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>


<h4 id="types.EmitterParam.type=SimpleRandom">3.24.1. EmitterParam.type="SimpleRandom"</h4>
<p>SimpleRandom defines a emitter which emits random particles which ranges between values.</p>
<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"type":</th>
    <td colspan="4">
<span class="string">"SimpleRandom"</span>
    </td>
  </tr>

  <tr id="verso.EmitterParam.type=SimpleRandom.TODO">
    <th>&nbsp;</th>
    <th colspan="3">"TODO"</th>
    <td colspan="4">
<span class="bold">TODO</span>
    </td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>


<h4 id="types.EmitterParam.type=SphericalRandom">3.24.2. EmitterParam.type="SphericalRandom"</h4>
<p>SphericalRandom defines a emitter which emits particles on a randomly on a sphere.</p>
<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"type":</th>
    <td colspan="4">
<span class="string">"SphericalRandom"</span>
    </td>
  </tr>

  <tr id="verso.EmitterParam.type=SphericalRandom.TODO">
    <th>&nbsp;</th>
    <th colspan="3">"TODO"</th>
    <td colspan="4">
<span class="bold">TODO</span>
    </td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>


<h3 id="types.Material3dParam">3.25. Material3dParam type</h3>
<table>
  <tr>
    <td>
TODO<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.TODO">TODO</a></span><br />
<span class="bold">Supported values:</span> TODO
    </td>
  </tr>
</table>


<h3 id="types.ParticlesParam">3.26. ParticlesParam type</h3>
<p>Defines a particle system.</p>
<table>
  <tr>
    <td>
asd<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.TODO">TODO</a></span><br />
<span class="bold">Supported values:</span> TODO
    </td>
  </tr>
</table>


<h3 id="types.PhongMaterialParam">3.27. PhongMaterialParam type</h3>
<table>
  <tr>
    <td>
TODO<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.TODO">TODO</a></span><br />
<span class="bold">Supported values:</span> TODO
    </td>
  </tr>
</table>


<h3 id="types.SequencerParam">3.28. SequencerParam type</h3>
<p>Defines when and how many particles are emitted.</p>
<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr id="verso.SequencerParam.type" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"type":</th>
    <td colspan="4">
Choose the type of sequencer to use.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="required">required</span><br />
    </td>
  </tr>

  <tr>
    <th>&nbsp;</th>
    <th colspan="3">"..."</th>
    <td colspan="4">
<span class="bold">Other parameters are dependent on the type.</span><br />
    </td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>


<h4 id="types.SequencerParam.type=BurstInterval">3.28.1. SequencerParam.type="BurstInterval"</h4>
<p>BurstInterval defines a sequencer which supports optional initial burst of particles, optional continous burst of particles every n seconds and optional constant rate of particles per second.</p>
<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"type":</th>
    <td colspan="4">
<span class="string">"BurstInterval"</span>
    </td>
  </tr>

  <tr id="verso.SequencerParam.type=BurstInterval.TODO">
    <th>&nbsp;</th>
    <th colspan="3">"TODO"</th>
    <td colspan="4">
<span class="bold">TODO</span>
    </td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>


<h3 id="types.ShaderParam">3.29. ShaderParam type</h3>

<table>
  <tr>
    <th colspan="4">{</th>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr id="verso.imageviewer.source" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"frag":</th>
    <td colspan="4">
Fragment shader file name to use. Relative to <span class="bold">"paths.shaders"</span> directory.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="optional">optional</span><br />
<span class="bold">Example:</span> <span class="string">"normalvisualizer3d.330.frag"</span><br />
<span class="bold">Support:</span> Shader sources should be GLSL and OpenGL 3.3 compatible.
    </td>
  </tr>

  <tr id="verso.imageviewer.source" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"vert":</th>
    <td colspan="4">
Vertex shader file name to use. Relative to <span class="bold">"paths.shaders"</span> directory.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="optional">optional</span><br />
<span class="bold">Example:</span> <span class="string">"normalvisualizer3d.330.vert"</span><br />
    </td>
  </tr>

  <tr id="verso.imageviewer.source" class="odd">
    <th>&nbsp;</th>
    <th colspan="3">"geom":</th>
    <td colspan="4">
Geometry shader file name to use. Relative to <span class="bold">"paths.shaders"</span> directory.<br />
<span class="bold">Type:</span> <span class="string"><a href="#types.string">string</a></span> <span class="optional">optional</span><br />
<span class="bold">Example:</span> <span class="string">"normalvisualizer3d.330.geom"</span><br />
    </td>
  </tr>

  <tr class="odd">
    <th colspan="4">}</th>
    <td colspan="4">&nbsp;</td>
  </tr>
</table>


<h2 id="full-examples">4. Full examples</h2>

<h3 id="full-examples-particles">4.1. particles.json</h3>

<pre><code class="json">
{
    "<a href="#demokit.format">format</a>": "DemoKit01",

    "<a href="#demokit.name">name</a>": "Enlil, king of all the lands, father of all the gods",
    "<a href="#demokit.version">version</a>": "2018/05/02 fix",
    "<a href="#demokit.authors">authors</a>": "Melem-Kish",

    "<a href="#demokit.paths">paths</a>": {
        "<a href="#demokit.paths.models">models</a>": "models",
        "<a href="#demokit.paths.shaders">shaders</a>": "shaders",
        "<a href="#demokit.paths.material">material</a>": "shaders/material",
        "<a href="#demokit.paths.music">music</a>": "music",
        "<a href="#demokit.paths.textures">textures</a>": "textures",
        "<a href="#demokit.paths.fonts">fonts</a>": "fonts",
        "<a href="#demokit.paths.particles">particles</a>": "particles",
        "<a href="#demokit.paths.gui">gui</a>": "gui",
        "<a href="#demokit.paths.guiIcons">guiIcons</a>": "gui/icons",
        "<a href="#demokit.paths.guiStyles">guiStyles</a>": "gui/styles"
    },

    "<a href="#demokit.music">music</a>": "soundtrack.mp3",
    "<a href="#demokit.muted">muted</a>": true,

    "<a href="#demokit.targetFps">targetFps</a>": 60,

    "<a href="#demokit.playmode">playmode</a>": "Development",

    "<a href="#demokit.duration">duration</a>": 123,
    "<a href="#demokit.loop">loop</a>": true,

    "<a href="#demokit.demoparts">demoparts</a>" : [
        { "<a href="#demokit.demoparts.name">name</a>": "Clear", "<a href="#demokit.demoparts.type">type</a>": "verso.clearscreen",
            "<a href="#demokit.demoparts.start">start</a>": 0, "<a href="#demokit.demoparts.duration">duration</a>": 3000, "<a href="#demokit.demoparts.priority">priority</a>": 0, "<a href="#demokit.demoparts.params">params</a>": {
        }},

        { "<a href="#demokit.demoparts.name">name</a>": "Particles", "<a href="#demokit.demoparts.type">type</a>": "verso.particles",
            "<a href="#demokit.demoparts.start">start</a>": 0, "<a href="#demokit.demoparts.duration">duration</a>": 123, "<a href="#demokit.demoparts.priority">priority</a>": 1, "<a href="#demokit.demoparts.params">params</a>": {
                "<a href="#types.ParticlesParam">particles</a>": {
                    "<a href="#types.ParticlesParam.texture">texture</a>": "spacemist.png",
                    "<a href="#types.ParticlesParam.blend">blend</a>": "Additive",
                    "<a href="#types.ParticlesParam.position">position</a>": [ 0.0, 0.0, 0.0 ],
                    "<a href="#types.ParticlesParam.trailSaveInterval">trailSaveInterval</a>": 0.2,
                    "<a href="#types.ParticlesParam.particleLimit">particleLimit</a>": 1000,
                    "<a href="#types.ParticlesParam.trailSize">trailSize</a>": 100
                },
                "<a href="#types.BehaviourParam">behaviour</a>": {
                    "<a href="#types.BehaviourParam.type">type</a>": "<a href="#types.BehaviourParam.SimpleGravity">SimpleGravity</a>",
                    "<a href="#types.BehaviourParam.SimpleGravity.gravity">gravity</a>": 9.81
                },
                "<a href="#types.EmitterParam">emitter</a>": {
                    "<a href="#types.EmitterParam.type">type</a>": "<a href="#types.EmitterParam.SphericalRandom">SphericalRandom</a>",
                    "<a href="#types.EmitterParam.SphericalRandom.radius">radius</a>": [5.0, 10.0],

                    "<a href="#types.EmitterParam.x">x</a>": 1,
                    "<a href="#types.EmitterParam.y">y</a>": 1,
                    "<a href="#types.EmitterParam.z">z</a>": 1,
                    "<a href="#types.EmitterParam.angle">angle</a>": 1,
                    "<a href="#types.EmitterParam.angleVelocity">angleVelocity</a>": 1,
                    "<a href="#types.EmitterParam.startSize">startSize</a>": 1,
                    "<a href="#types.EmitterParam.endSize">endSize</a>": 1,
                    "<a href="#types.EmitterParam.totalLifeTime">totalLifeTime</a>": 1,
                    "<a href="#types.EmitterParam.red">red</a>": 1,
                    "<a href="#types.PartiEmitterParamclesParam.green">green</a>": 1,
                    "<a href="#types.EmitterParam.blue">blue</a>": 1,
                    "<a href="#types.EmitterParam.startAlpha">startAlpha</a>": 1,
                    "<a href="#types.EmitterParam.endAlpha">endAlpha</a>": 1

                },
                "<a href="#types.SequencerParam">sequencer</a>": {
                    "<a href="#types.SequencerParam.type">type</a>": "<a href="#types.SequencerParam.BurstInterval">BurstInterval</a>"
                }
            }
        },

        { "<a href="#demokit.demoparts.name">name</a>": "Particles", "<a href="#demokit.demoparts.type">type</a>": "verso.particles",
            "<a href="#demokit.demoparts.start">start</a>": 10, "<a href="#demokit.demoparts.duration">duration</a>": 123, "<a href="#demokit.demoparts.priority">priority</a>": 1, "<a href="#demokit.demoparts.params">params</a>": {
                "<a href="#types.ParticlesParam">particles</a>": {
                    "<a href="#types.ParticlesParam.texture">texture</a>": "explosion.png"
                },
                "<a href="#types.BehaviourParam">behaviour</a>": {
                    "<a href="#types.BehaviourParam.type">type</a>": "<a href="#types.BehaviourParam.SimpleGravity">SimpleGravity</a>"
                },
                "<a href="#types.EmitterParam">emitter</a>": {
                    "<a href="#types.EmitterParam.type">type</a>": "<a href="#types.EmitterParam.SimpleRandom">SimpleRandom</a>",
                    "<a href="#types.EmitterParam.SimpleRandom.xVelocity">xVelocity</a>": 1,
                    "<a href="#types.EmitterParam.SimpleRandom.yVelocity">yVelocity</a>": 1,
                    "<a href="#types.EmitterParam.SimpleRandom.zVelocity">zVelocity</a>": 1
                },
                "<a href="#types.SequencerParam">sequencer</a>": {
                    "<a href="#types.SequencerParam.type">type</a>": "<a href="#types.SequencerParam.BurstInterval">BurstInterval</a>"
                }
            }
        }
    ]
}
</code></pre>


</body>
</html>
